/*
 * Copyright (c) 2000  Rijkswaterstaat 
 *                     Adviesdienst Verkeer en Vervoer
 *
 * File:               CRAPTAB.C
 *  
 * Regelprogramma vri: Voorbeeld B: Pleinregeling
 *
 * datum: 02-02-2000
 */



#include "crtypes.h"
#include "crapcod.h"
#include "craptab.h"
#include "crapdef.h"


/*     BLOKKENschema  */ 
struct BLOKKEN  BLOKKEN_tabel[] ={
/*     BLOK(),  SGn,   PRIM + ALT + WSGR,  */

       BK1,     SG02,  PRIM,
       BK1,     SG08,  PRIM,
       BK1,     SG62,  PRIM,
       BK1,     SG68,  PRIM,
  
       BK2,     SG04,  PRIM,
       BK2,     SG05,  PRIM,
       BK2,     SG10,  PRIM,
       BK2,     SG11,  PRIM,
       BK2,     SG65,  PRIM,
       BK2,     SG71,  PRIM,      

       STOP};


/*     CONFLICT- en (garantie)ontruimingstijden matrix  */
struct CONFLICT  CONFLICT_tabel[] = {
/*     SGn,      conflicterende SGj,  GO_TIJD,  O_TIJD,  */
       SG02,     SG65,                0.0,      0.0, 
       SG04,     SG68,                0.0,      0.0, 
       SG05,     SG68,                0.0,      0.0, 
       SG08,     SG71,                0.0,      0.0, 
       SG10,     SG62,                0.0,      0.0, 
       SG11,     SG62,                0.0,      0.0, 
       SG62,     SG10,                0.0,      0.0, 
       SG62,     SG11,                0.0,      0.0, 
       SG65,     SG02,                0.0,      0.0, 
       SG68,     SG04,                0.0,      0.0, 
       SG68,     SG05,                0.0,      0.0, 
       SG71,     SG08,                0.0,      0.0,       
       STOP};
 
 
/*     FICTief CONFLICT matrix  */
struct FICT_CONFLICT    FICT_CONFLICT_tabel[] = {
/*     SGn,             fictief conflicterende SGj,  */
       SG02,            SG05,
       SG02,            SG10,
       SG02,            SG11,
       SG04,            SG08,
       SG05,            SG08,
       SG08,            SG11,      
       STOP};
 
 

/*     extra op te geven SG'en j volgens BS_H5 formule ac  */
struct SG_BS_H5ac   SG_BS_H5ac_tabel[] ={
/*     SGn,         SGj,      */
       SG02,        SG05,
       SG02,        SG10,
       SG02,        SG11,
       SG04,        SG08,
       SG05,        SG08,
       SG08,        SG11,      
       STOP};

/*
 * Toelichting:
 * De indirect conflicterende signaalgroepen (b.v. SG02 versus SG05) zijn 
 * hier fictief conflicterend gemaakt.
 * De fictieve conflictrichtingen zijn bij de extra op te geven   SG'en j 
 * volgens de BS hoofdstuk 5 formule ac opgenomen om elkaars MVG te 
 * beeindigen bij het RVG van de fictieve conflictrichting.
 */


/*     SignaalGroep-TIJDEN tabel */
struct SG_TIJDEN      SG_TIJDEN_tabel[] ={
/*     SGn,  GG_TIJD, VG_TIJD GGL_TIJD, GL_TIJD, GR_TIJD,  */
       SG02, 4.0,     4.0,    4.0,      4.0,     2.0, 
       SG04, 4.0,     4.0,    4.0,      4.0,     2.0, 
       SG05, 4.0,     4.0,    4.0,      4.0,     2.0, 
       SG08, 4.0,     4.0,    4.0,      4.0,     2.0, 
       SG10, 4.0,     4.0,    4.0,      4.0,     2.0, 
       SG11, 4.0,     4.0,    4.0,      4.0,     2.0, 
       SG62, 5.0,     5.0,    4.0,      4.0,     2.0, 
       SG65, 5.0,     5.0,    4.0,      4.0,     2.0, 
       SG68, 5.0,     5.0,    4.0,      4.0,     2.0, 
       SG71, 5.0,     5.0,    4.0,      4.0,     2.0,       
       STOP};
 

/*     MG TIJDEN tabel  */
struct MG_TIJDEN  MG_TIJDEN_tabel[] = {
/*     SGn,       MG_TIJD, MG_TIJD1, MG_TIJD2, MG_TIJD3,  */
       SG02,      40.0,    NG,       NG,       NG,
       SG04,      40.0,    NG,       NG,       NG,
       SG05,      40.0,    NG,       NG,       NG,
       SG08,      40.0,    NG,       NG,       NG,
       SG10,      40.0,    NG,       NG,       NG,
       SG11,      40.0,    NG,       NG,       NG,
       SG62,      60.0,    NG,       NG,       NG,
       SG65,      60.0,    NG,       NG,       NG,
       SG68,      60.0,    NG,       NG,       NG,
       SG71,      60.0,    NG,       NG,       NG,      
       STOP};
 

/*     HiaatTIJDEN tabel  */
struct H_TIJDEN  H_TIJDEN_tabel[] = {
/*     SGn,      H1e_TIJD,  H2e_TIJD,  */
       SG02,     1.0,       2.5,
       SG04,     1.0,       NG,
       SG05,     1.0,       2.5,
       SG08,     1.0,       2.5,
       SG10,     1.0,       NG,
       SG11,     1.0,       2.5,
       SG62,     1.0,       2.0,
       SG65,     1.0,       2.0,
       SG68,     1.0,       2.0,
       SG71,     1.0,       2.0,    
       STOP};


/*     SignaalGroep-DETECTIE tabel */
struct SG_DETECTIE SG_DETECTIE_tabel[] = {
/*     D(),        type, SGn,       functie,        */
       SG02_1,     DP,   SG02,      AVR + BS_H5p,
       SG02_2,     DP,   SG02,      AVR + BS_H5p,
       SG02_3,     DP,   SG02,      AVR + BS_H5p,
       SG02_4,     DP,   SG02,      AVR + H1e,
       SG02_5,     DP,   SG02,      AVR + H1e,
       SG02_6,     DP,   SG02,      AVR + H1e,
       SG02_7,     DP,   SG02,      AVR + H2e,
       SG02_8,     DP,   SG02,      AVR + H2e,
       SG02_9,     DP,   SG02,      AVR + H2e,
 
       SG04_1,     DP,   SG04,      AVR + BS_H5p,
       SG04_2,     DP,   SG04,      AVR + H1e,
 
       SG05_1,     DP,   SG05,      AVR + BS_H5p,
       SG05_2,     DP,   SG05,      AVR + BS_H5p,
       SG05_3,     DP,   SG05,      AVR + H1e,
       SG05_4,     DP,   SG05,      AVR + H1e,
       SG05_5,     DP,   SG05,      AVR + H2e,
       SG05_6,     DP,   SG05,      AVR + H2e,
 
       SG08_1,     DP,   SG08,      AVR + BS_H5p,
       SG08_2,     DP,   SG08,      AVR + BS_H5p,
       SG08_3,     DP,   SG08,      AVR + BS_H5p,
       SG08_4,     DP,   SG08,      AVR + H1e,
       SG08_5,     DP,   SG08,      AVR + H1e,
       SG08_6,     DP,   SG08,      AVR + H1e,
       SG08_7,     DP,   SG08,      AVR + H2e,
       SG08_8,     DP,   SG08,      AVR + H2e,
       SG08_9,     DP,   SG08,      AVR + H2e,
 
       SG10_1,     DP,   SG10,      AVR + BS_H5p,
       SG10_2,     DP,   SG10,      AVR + H1e,
 
       SG11_1,     DP,   SG11,      AVR + BS_H5p,
       SG11_2,     DP,   SG11,      AVR + BS_H5p,
       SG11_3,     DP,   SG11,      AVR + H1e,
       SG11_4,     DP,   SG11,      AVR + H1e,
       SG11_5,     DP,   SG11,      AVR + H2e,
       SG11_6,     DP,   SG11,      AVR + H2e,
 
       SG62_1,     DP,   SG62,      AVR + BS_H5p,
       SG62_2,     DP,   SG62,      AVR + BS_H5p,
       SG62_3,     DP,   SG62,      AVR + H1e,
       SG62_4,     DP,   SG62,      AVR + H1e,
       SG62_5,     DP,   SG62,      H2e,

       SG65_1,     DP,   SG65,      AVR + BS_H5p,
       SG65_2,     DP,   SG65,      AVR + BS_H5p,
       SG65_3,     DP,   SG65,      AVR + H1e,
       SG65_4,     DP,   SG65,      AVR + H1e,
       SG65_5,     DP,   SG65,      H2e,
 
       SG68_1,     DP,   SG68,      AVR + BS_H5p,
       SG68_2,     DP,   SG68,      AVR + BS_H5p,
       SG68_3,     DP,   SG68,      AVR + H1e,
       SG68_4,     DP,   SG68,      AVR + H1e,
       SG68_5,     DP,   SG68,      H2e,

       SG71_1,     DP,   SG71,      AVR + BS_H5p,
       SG71_2,     DP,   SG71,      AVR + BS_H5p,
       SG71_3,     DP,   SG71,      AVR + H1e,
       SG71_4,     DP,   SG71,      AVR + H1e,
       SG71_5,     DP,   SG71,      H2e,
       STOP};


/*     tabel voor SG die gebruik maken van WSRH  */

/*
 * Toelichting:
 * Om gebruik te kunnen maken van de standaard wachtstandroodhulpfunctie 
 * bij de MVG_OP, dient deze hier te worden toegepast.
 */

struct SG_WSRH    SG_WSRH_tabel[] = {
/*     SGn,             */
       TOEPASSEN,      
       STOP};



/*     TIJDEN       tabel  */
struct TIJDEN       TIJDEN_tabel[] = {
/*     TIJD(),      instelling,  */

       nalooptijd_02_62,   10.0,  /* nalopen */
       nalooptijd_05_65,   10.0,
       nalooptijd_08_68,   10.0,
       nalooptijd_11_71,   10.0,

       NaloopInGL_02,       1.0,
       NaloopInGL_05,       1.0,
       NaloopInGL_08,       1.0,
       NaloopInGL_11,       1.0,

       BO_tijd_02,          4.0,  /*  voor BO_OP  */
       BO_tijd_04,          4.0,
       BO_tijd_05,          4.0,
       BO_tijd_08,          4.0,
       BO_tijd_10,          4.0,
       BO_tijd_11,          4.0,
       BO_tijd_62,          4.0,
       BO_tijd_65,          4.0,
       BO_tijd_68,          4.0,
       BO_tijd_71,          4.0,

       TR_tijd_02,         35.0,  /* voor TR_OP */
       TR_tijd_04,         35.0,
       TR_tijd_05,         35.0,
       TR_tijd_08,         35.0,
       TR_tijd_10,         35.0,
       TR_tijd_11,         35.0,
/*
 * Toelichting:
 * De tijden voor de TR_OP houden de "voedende richting" tegen 
 * tijdens groen van een verweg gelegen "fictiefconflictrichting".
 * De tijden voor de TR_OP dienen daarom zodanig te zijn ingesteld 
 * dat verkeer, dat bij de voedende richting start, bij de volgrichting
 * ongehinderd kan doorrijden. Hierbij wordt uitgegaan van een
 * maximale groenverlenging van de "fictiefconflictrichting". 
 *
 * In dit voorbeeld is uitgegaan van een maximumgroentijd per 
 * signaalgroep. Indien echter meerdere maximumgroentijden voor de 
 * bedoelde fictiefconflictrichting zijn gespecificeerd, is het aan 
 * te bevelen tevens meerdere tijden voor de TR_OP te specificeren.
 *
 * Meerdere tijden voor een TR_OP is echter lastig bij het beheer 
 * van de installatie. Dit kan men oplossen door de instelling 
 * van de tijd voor de TR_OP programmatisch te berekenen. Er is 
 * dan, ook bij meerdere maximumgroentijden, maar een tijd voor de 
 * TR_OP nodig. 
 * Dit berekenen vindt als volgt plaats:
 * - er wordt een andere tijd geintroduceerd en
 * - de instelling van de tijd voor de TR_OP wordt bepaald door de 
 *   instelling van de andere tijd af te trekken van de instelling van 
 *   de maximumgroentijd.
 * Voor het hier bedoelde aftrekken kan gebruik gemaakt worden van de 
 * standaard nr. 2: "aftrekken tijden".
 * 
 * E.e.a. wordt met in onderstaand schema verduidelijkt.
 * In dit schema is SG11 een fictiefconflictrichting van de 
 * sturende richting SG02 en is SG62 de volgrichting van SG02.
 * De gebruikte symbolen zijn 
 * - groen:            --------
 * - geel:             XXX 
 * - een tijd:         +++++++
 * - startmoment SG02: |
 * 
 * 
 * SG11                ----------------XXX
 *                               |
 * SG02                          --------------------XXX
 * SG62                                      ----------------XXX
 * tijd voor de TR_OP  ++++++++++
 * andere tijd                   ++++++
 * 
 * SG02 moet worden tegengehouden tot het moment |. Dit moment 
 * moet zodanig worden gekozen dat de periode van begin groen 
 * SG02 tot begin groen SG62 gelijk is aan de afstandrijtijd van 
 * SG02 naar SG62.
 * In de regeling moet de som van
 * - de periode van moment | tot einde goen SG11,
 * - de geeltijd van SG11 en
 * - de ontruiming van SG11 naar SG62
 * gelijk zijn aan deze afstandrijtijd.
 * Moment | wordt bepaald met behulp van de tijd voor de TR_OP 
 * die start bij begin groen SG11.
 * De instelling van de tijd voor de TR_OP kan vooraf, dus niet 
 * programmatisch, worden bepaald door rekening te houden met 
 * de lengte van de maximumgroentijd van SG11 en de hierboven 
 * genoemde perioden die samen gelijk zijn aan de afstandrijtijd.
 * De instelling van de tijd voor de TR_OP kan echter ook 
 * programmatisch worden berekend door de instelling van de andere 
 * tijd af te trekken van de maximumgroentijd van SG11.
 * De instelling van deze andere tijd moet dan gelijk zijn aan 
 * de afstandrijtijd minus de som van de geeltijd van SG11 
 * en de ontruimingstijd van SG11 naar SG62.
 */
       STOP};
  

/*     BK gebonden OPTIE:  BO_OP tabel  */

Bool alg_BO_funct(Int16 n, Int16 i){
     return ROG(n) && A(n) || RVG(n) || G(n) && TIJD(i); 
}

Bool BO_funct_01 (void) {
  /* eerst de tijden */
  if (begin_G(SG02))    start_TIJD(BO_tijd_02);
  if (begin_G(SG04))    start_TIJD(BO_tijd_04);
  if (begin_G(SG05))    start_TIJD(BO_tijd_05);
  if (begin_G(SG08))    start_TIJD(BO_tijd_08);
  if (begin_G(SG10))    start_TIJD(BO_tijd_10);
  if (begin_G(SG11))    start_TIJD(BO_tijd_11);
  if (begin_G(SG62))    start_TIJD(BO_tijd_62);
  if (begin_G(SG65))    start_TIJD(BO_tijd_65);
  if (begin_G(SG68))    start_TIJD(BO_tijd_68); 
  if (begin_G(SG71))    start_TIJD(BO_tijd_71); 

     return alg_BO_funct (SG02, BO_tijd_02) ||
            alg_BO_funct (SG62, BO_tijd_62) ||
            alg_BO_funct (SG08, BO_tijd_08) ||
            alg_BO_funct (SG68, BO_tijd_68) ; 
}

Bool BO_funct_02 (void) {
     return alg_BO_funct (SG04, BO_tijd_04) ||
            alg_BO_funct (SG05, BO_tijd_05) ||
            alg_BO_funct (SG65, BO_tijd_65) ||
            alg_BO_funct (SG10, BO_tijd_10) ||
            alg_BO_funct (SG11, BO_tijd_11) ||
            alg_BO_funct (SG71, BO_tijd_71) ; 
}

/*
 * Toelichting:
 * De beide blokken worden m.b.v. een BO_OP opgehouden om een evenwichtig 
 * verkeersbeeld te bevorderen, zonder dat dit nadelige invloed heeft op de 
 * verdere afwikkeling. 
 */

struct BK_OPTIE   BO_OP_tabel[] = {
/*     optie voor BLOK(), functie t.b.v. de optie,   */
       BK1,       BO_funct_01,
       BK2,       BO_funct_02,
       STOP};


/*  SG gebonden OPTIE: MA_OP tabel  */

Bool alg_MA_funct (Int16 n) {
     return ROG(n) && A(n) || RVG(n) || G(n) && !MVG(n);
}

Bool MA_funct_62 (void) { return  alg_MA_funct(SG02); }
Bool MA_funct_65 (void) { return  alg_MA_funct(SG05); }
Bool MA_funct_68 (void) { return  alg_MA_funct(SG08); }
Bool MA_funct_71 (void) { return  alg_MA_funct(SG11); }

/*
 * Toelichting:
 * Indien de voedende signaalgroep een aanvraag heeft, krijgt de 
 * volgrichting een meeaanvraag.
 */

struct SG_OPTIE        MA_OP_tabel[] = {
/*     optie voor SGn, functie t.b.v. de optie,   */
       SG62,           MA_funct_62,
       SG65,           MA_funct_65,
       SG68,           MA_funct_68,
       SG71,           MA_funct_71,
       STOP};


/*     SG gebonden OPTIE:  MVG_OP tabel  */

Bool MVG_funct (void) { return (WSRH); }

/*
 * Toelichting:
 * Omdat dit een wachtstandrood regeling is, is voor alle signaalgroepen de 
 * standaard wachtstandrood-hulpfunctie in de MVG_OP opgenomen.
 */

struct SG_OPTIE    MVG_OP_tabel[] = {
/*     optie voor SGn, functie t.b.v. de optie,   */
       SG02,          MVG_funct,
       SG04,          MVG_funct,
       SG05,          MVG_funct,
       SG08,          MVG_funct,
       SG10,          MVG_funct,
       SG11,          MVG_funct,
       SG62,          MVG_funct,
       SG65,          MVG_funct,
       SG68,          MVG_funct,
       SG71,          MVG_funct,
       STOP};


/*   SG gebonden OPTIE: TR_OP tabel  */
/*   Eerst de algemene functies      */

Bool alg_TR_funct1 (Int16 n){
     return ROG(n) && A(n) || RVG(n) || G(n) && !MVG(n);   
}

Bool alg_TR_funct2 (Int16 n, Int16 i){
     return ROG(n) && A(n) || RVG(n) || G(n) && TIJD(i) && !MVG(n);   
}

/*   Vervolgens de SG gebonden functies */

Bool TR_funct_02 (void) {
  /* eerst de tijden */
  if (begin_G(SG02))    start_TIJD(TR_tijd_02); 
  if (begin_G(SG04))    start_TIJD(TR_tijd_04); 
  if (begin_G(SG05))    start_TIJD(TR_tijd_05); 
  if (begin_G(SG08))    start_TIJD(TR_tijd_08); 
  if (begin_G(SG10))    start_TIJD(TR_tijd_10); 
  if (begin_G(SG11))    start_TIJD(TR_tijd_11); 

  return  alg_TR_funct1 (SG05) ||
          alg_TR_funct2 (SG10, TR_tijd_10) ||
          alg_TR_funct2 (SG11, TR_tijd_11) ;
}
Bool TR_funct_05 (void) {
  return  alg_TR_funct1 (SG08) ||
          alg_TR_funct2 (SG02, TR_tijd_02) ;
}
Bool TR_funct_08 (void) {
  return  alg_TR_funct1 (SG11) ||
          alg_TR_funct2 (SG05, TR_tijd_05) ||
          alg_TR_funct2 (SG04, TR_tijd_04) ;
}
Bool TR_funct_11 (void) {
  return  alg_TR_funct1 (SG02) ||
          alg_TR_funct2 (SG08, TR_tijd_08) ;
}

/*
 * Toelichting:
 * De TR_OP wordt hier gebruikt om de realisatie tegen te houden gedurende de 
 * tijd dat een fictieve conflictrichting (gedeeltelijk) in groen staat. In 
 * het geval dit slechts gedeeltelijk nodig is, is ook een tijd gespecificeerd. 
 * Door deze tijd kan  b.v. SG02 nog in het groen van SG11 starten. 
 * Dit is mogelijk omdat het verkeer op SG02 eerst nog de afstand naar SG62 
 * moet overbruggen. 
 * Indien deze tijd te krap wordt ingesteld, zal het verkeer bij SG62 in 
 * moeten houden. Indien SG11 niet volledig uitverlengt, kan SG02 bij 
 * begin_MVG van SG11 starten. 
 */

struct SG_OPTIE        TR_OP_tabel[] = {
/*     optie voor SGn, functie t.b.v. de optie,   */
       SG02,           TR_funct_02,
       SG05,           TR_funct_05,
       SG08,           TR_funct_08,
       SG11,           TR_funct_11,
       STOP};


/*     SG gebonden OPTIE: VAG_OP tabel  */

Bool alg_VAG_funct (Int16 n) {
     return ROG(n) || RVG(n) || G(n) && !MVG(n); 
}

Bool VAG_funct_62 (void) {
  if (begin_PG(SG02,BK1))     set_HF(REAL02);
  if (begin_PG(SG62,BK1))     set_HF(REAL62);
  if (HF(REAL02) && HF(REAL62)) { 
      reset_HF(REAL02); 
      reset_HF(REAL62);
  }
  return  HF(REAL02) || alg_VAG_funct(SG02) ;   
}

Bool VAG_funct_65 (void) { 
  if (begin_PG(SG05,BK2))     set_HF(REAL05);
  if (begin_PG(SG65,BK2))     set_HF(REAL65);
  if (HF(REAL05) && HF(REAL65)) { 
      reset_HF(REAL05); 
      reset_HF(REAL65);
  }
  return  HF(REAL05) || alg_VAG_funct(SG05) ;   
} 

Bool VAG_funct_68 (void) { 
  if (begin_PG(SG08,BK1))     set_HF(REAL08);
  if (begin_PG(SG68,BK1))     set_HF(REAL68);
  if (HF(REAL08) && HF(REAL68)) { 
      reset_HF(REAL08); 
      reset_HF(REAL68);
  }
  return  HF(REAL08) || alg_VAG_funct(SG08) ;   
}

Bool VAG_funct_71 (void) { 
  if (begin_PG(SG71,BK2))     set_HF(REAL71);
  if (begin_PG(SG11,BK2))     set_HF(REAL11);
  if (HF(REAL71) && HF(REAL11)) { 
      reset_HF(REAL71);
      reset_HF(REAL11); 
  }
  return  HF(REAL11) || alg_VAG_funct (SG11) ;   
}

/*
 * Toelichting:
 * De coordinatie tussen de voedende- en de volgrichting wordt in  het VAG2e 
 * van de volgrichting gerealiseerd.
 */

struct SG_OPTIE        VAG_OP_tabel[] = {
/*     optie voor SGn, functie t.b.v. de optie,   */
       SG62,           VAG_funct_62,
       SG65,           VAG_funct_65,
       SG68,           VAG_funct_68,
       SG71,           VAG_funct_71,
       STOP};


/*  SG gebonden OPTIE: VMG_OP tabel  */

Bool alg_VMG_funct(Int16 n, Int16 i){
     return G(n) || GL_TIJD(n) || TIJD(i); 
}

Bool VMG_funct_62 (void) { 

  /* eerst de tijden */
  if (begin_GL(SG02))                       start_TIJD(NaloopInGL_02);
  if (begin_GL(SG05))                       start_TIJD(NaloopInGL_05);
  if (begin_GL(SG08))                       start_TIJD(NaloopInGL_08);
  if (begin_GL(SG11))                       start_TIJD(NaloopInGL_11);

  if ((G(SG02) || TIJD(NaloopInGL_02)) && 
      (D(SG02_2) || D(SG02_3)))             start_TIJD(nalooptijd_02_62); 
  if ((G(SG05) || TIJD(NaloopInGL_05)) && 
      (D(SG05_1) || D(SG05_2)))             start_TIJD(nalooptijd_05_65); 
  if ((G(SG08) || TIJD(NaloopInGL_08)) && 
      (D(SG08_2) || D(SG08_3)))             start_TIJD(nalooptijd_08_68); 
  if ((G(SG11) || TIJD(NaloopInGL_11)) &&       
      (D(SG11_1) || D(SG11_2)))             start_TIJD(nalooptijd_11_71); 

     return  alg_VMG_funct (SG02, nalooptijd_02_62); 
}

Bool VMG_funct_65 (void) { 
     return  alg_VMG_funct (SG05, nalooptijd_05_65); 
}

Bool VMG_funct_68 (void) { 
     return  alg_VMG_funct (SG08, nalooptijd_08_68); 
}

Bool VMG_funct_71 (void) { 
     return  alg_VMG_funct (SG11, nalooptijd_11_71); 
}

/*
 * Toelichting:
 * De uiteindelijke voertuigafhankelijke naloop op basis van detectie-
 * informatie wordt in het MVG van de volgrichting gerealiseerd.
 */

struct SG_OPTIE        VMG_OP_tabel[] = {
/*     optie voor SGn, functie t.b.v. de optie,   */
       SG62,           VMG_funct_62,
       SG65,           VMG_funct_65,
       SG68,           VMG_funct_68,
       SG71,           VMG_funct_71,
       STOP};


/*     REGELING tabel                             */
struct REGELING   REGELING_tabel[] = {
/*     Nummer,  */
       1,
       STOP};


struct SG_OPTIE         VAA_OP_tabel[] = { STOP};
struct SG_OPTIE         PPV_OP_tabel[] = { STOP};

/*
 * Toelichting:
 * Omdat slechts twee blokken gedefinieerd zijn, kunnen de VAA_OP en 
 * de PPV_OP tabellen leeg gelaten worden.
 */

struct WB               WB_tabel[] = { STOP};
struct SG_BS_H5t        SG_BS_H5t_tabel[] ={ STOP};
struct SG_BS_H66        SG_BS_H66_tabel[] ={ STOP};
struct E_MG_TIJDEN      E_MG_TIJDEN_tabel[] = { STOP};
struct E_H_TIJDEN       E_H_TIJDEN_tabel[] = { STOP};
struct SG_RGA           SG_RGA_tabel[] = { STOP};
struct FIETS_VOETG_R    FIETS_VOETG_R_tabel[] = { STOP};
struct SG_MAH3          SG_MAH3_tabel[] = { STOP};
struct SG_PPAH          SG_PPAH_tabel[] = { STOP};
struct KLOKKEN          KLOKKEN_tabel[] = { STOP};
struct SCHAKELAAR       SCHAKELAAR_tabel[] = { STOP};
struct EPARMS           EPARMS_tabel[] = { STOP};
struct SG_BK_OPTIE      PPP_OP_tabel[] = { STOP};
struct SG_OPTIE         PPB_OP_tabel[] = { STOP};
struct SG_BK_OPTIE      PPA_OP_tabel[] = { STOP};
struct SG_BK_OPTIE      VNM_OP_tabel[] = { STOP};
struct SG_OPTIE         AFK_OP_tabel[] = { STOP};
struct SG_OPTIE         BL_OP_tabel[] = { STOP};
struct SG_OPTIE         RVG_OP_tabel[] = { STOP};
struct KOPPEL           KOPPEL_tabel[] = { STOP};

